Update several QA tests, configure magic in xfstests directory.
[xfstests-dev.git] / tools / srcdiff
1 #!/usr/bin/perl -w
2 use strict;
3
4 # srcdiff is used to compare current user level code with the current
5 # kernel code and advise of any differences between files which are
6 # sharing some or all of their content.
7
8 # There are two classes of sharing which we will check - header files
9 # in the include directory, which must be exactly the same (use diff)
10 # and source files which contain routines which must be exactly the
11 # same (but the userland file is always a subset of the kernel file,
12 # and hence a more flexible mechanism to "diff" is required).
13
14 # NB: to cross check that srcdiff is finding all the functions in the
15 #     user source file, providing you have "mkproto" installed, you
16 #     can "cd xfsprogs/libxfs" and cut&paste this in a bourne shell:
17 #     $ for file in xfs_*.c; do
18 #     > mkproto -nps < $file | perl -ne '
19 #     > END { print "    $count\t- " }
20 #     > s/^.* (xfs\w+|\*xfs\w+|xlog\w+|\*xlog\w+) \(.*/\1/ && { $count++ }'
21 #     > echo $file
22 #     > done
23 # (compare this to "srcdiff | fgrep Total:")
24
25
26 die "WORKAREA not set" unless defined $ENV{'WORKAREA'};
27 die "KWORKAREA not set" unless defined $ENV{'KWORKAREA'};
28 chdir $ENV{'WORKAREA'};
29 my $kworkarea = $ENV{'KWORKAREA'};
30 my $xdiff = $ENV{'XDIFF'};
31 my $quiet = 0;
32 my $usage = 0;
33
34 foreach (@ARGV) {
35         if (/^-q$/) {
36                 $quiet++;
37         } else {
38                 print STDERR "Illegal option $_\n";
39                 $usage++;
40         }
41 }
42
43 if ($usage) {
44     print STDERR "Usage: $0 [-q]\n";
45     exit 1;
46 }
47
48 my @pkglist = qw( xfstests attr acl dmapi xfsdump xfsprogs );
49 my @difflist = qw(
50         xfs_ag.h  xfs_alloc.h  xfs_alloc_btree.h xfs_arch.h
51         xfs_attr_leaf.h  xfs_attr_sf.h  xfs_bit.h  xfs_bmap.h
52         xfs_bmap_btree.h  xfs_btree.h  xfs_buf_item.h
53         xfs_da_btree.h  xfs_dfrag.h  xfs_dinode.h  xfs_dir.h
54         xfs_dir2.h  xfs_dir2_block.h  xfs_dir2_data.h
55         xfs_dir2_leaf.h  xfs_dir2_node.h  xfs_dir2_sf.h
56         xfs_dir_leaf.h  xfs_dir_sf.h  xfs_extfree_item.h  xfs_ialloc.h
57         xfs_imap.h  xfs_ialloc_btree.h  xfs_inode.h  xfs_inode_item.h
58         xfs_inum.h  xfs_log.h  xfs_log_priv.h  xfs_log_recover.h
59         xfs_mount.h  xfs_quota.h  xfs_rtalloc.h
60         xfs_sb.h  xfs_trans.h  xfs_trans_space.h  xfs_types.h  xfs_fs.h
61 );
62
63 sub straightdiff {
64         my ( $file, $prefix1, $prefix2 ) = @_;
65
66         `diff $prefix1/$file $prefix2/$file >/dev/null 2>&1`;
67         if (!$quiet) {
68                 print sprintf("\t%-35s ... ", $file);
69                 if ($? != 0)    { printf("FAILED\n(%s/%s differs to %s/%s)\n",
70                                          $prefix1, $file, $prefix2, $file); }
71                 else            { print "ok\n"; }
72         
73         } elsif ($? != 0) {
74                 printf("\t%-35s ... FAILED\n(%s/%s differs to %s/%s)\n",
75                         $file, $prefix1, $file, $prefix2, $file);
76         }
77 }
78
79 #
80 # xfstests directory m4 directory is a repository of all of the
81 # custom m4 macros used in the packages we look after.
82 #
83 sub m4macrodiff {
84         my ( $package ) = @_;
85
86         foreach (`ls $package/m4/*.m4`) {
87                 my $m4 = `basename $_`;
88                 chomp($m4);
89                 straightdiff $m4, "$package/m4", "xfstests/m4";
90         }
91 }
92
93 my $first = shift @pkglist;
94 foreach (@pkglist) {
95         print "\n=== Checking $_ package ===\n";
96         m4macrodiff $_;
97         straightdiff 'buildrules', "$first/include", "$_/include";
98         straightdiff 'buildmacros', "$first/include", "$_/include";
99         straightdiff 'Makefile', "$first/build", "$_/build";
100         straightdiff 'Makefile', "$first/build/rpm", "$_/build/rpm";
101         straightdiff 'Makefile', "$first/build/tar", "$_/build/tar";
102 }
103 print "\n=== Checking headers ===\n";
104 foreach (@difflist) {
105         straightdiff $_, 'xfsprogs/include', "$kworkarea/fs/xfs";
106 }
107 straightdiff 'dmapi_kern.h', 'dmapi/include', "$kworkarea/fs/xfs/dmapi";
108 straightdiff 'dmapi.h', 'dmapi/include', "$kworkarea/fs/xfs/dmapi";
109
110
111 # setstate
112 # Implements a tri-state FSA, see comments for state transitions
113 #  (knows about the way the XFS kernel code is written, & makes
114 #   some assumptions so as to not need to parse generic C code).
115 # Accepts one line at a time from a source file, picking out the
116 #   function bodies so they can be subsequently compared.
117
118
119 my $line;       # line number in current source file
120 my $state;      # current FSA state
121 my $funcbody;   # current function body (contents)
122
123 sub setstate {
124         my ( $newline ) = @_;
125         $line++;
126
127         # - state 0:
128         #       if line looks like start of a function, transition to 1
129         #               & squirrel line away as line 1 of current function
130         if ($state == 0) {
131                 if ($newline =~ m/^[xfs|xlog]/) {
132                         $state = 1;
133                         $funcbody = $newline;
134                 }
135         }
136
137         # - state 1:
138         #       if line looks like start of a function, stay here
139         #               & squirrel line away as line 1 of current function
140         #       otherwise if line isn't start of function body,
141         #               squirrel line away as next line of current function
142         #               (args/..., but not sure this is a real function yet)
143         #       otherwise (start of function)
144         #               squirrel line away as next line of current function
145         #               transition to state 2
146         elsif ($state == 1) {
147                 if ($newline =~ m/^[xfs|xlog]/) {
148                         $funcbody = $newline;
149                 }
150                 elsif ($newline =~ m/^\{/) {
151                         $state = 2;
152                         $funcbody .= $newline;
153                 }
154         }
155
156         # - state 2:
157         #       if line looks like end of function body,
158         #               squirrel line away as last line of current function
159         #               tell someone we have a complete function ready
160         #               transition to state 0
161         #       otherwise
162         #               squirrel line away as next line of current function
163         elsif ($state == 2) {
164                 $funcbody .= $newline;
165                 if ($newline =~ m/^\}/) {
166                         $state = 0;
167                         return $funcbody;
168                 }
169         }
170
171         else {
172                 die "unknown state transition";
173         }
174         return undef;   # i.e. not at end of a function
175 }
176
177 sub listfuncs {
178         my ( $file ) = @_;
179         my @funcs;
180
181         $funcbody = '';
182         $state = $line = 0;
183
184         open(USER, "$file") || die "cannot open $file";
185         while (<USER>) {
186                 my $func = setstate($_);
187                 push @funcs, $func if (defined($func)); # store function away
188         }
189         close USER;
190         return @funcs;
191 }
192
193 sub hashfuncs {
194         my ( $file ) = @_;
195         my %funcs;
196
197         $funcbody = '';
198         $state = $line = 0;
199
200         open(KERN, "$file") || die "cannot open $file";
201         while (<KERN>) {
202                 my $func = setstate($_);
203                 if (defined($func)) {
204                         $func =~ m/^([xfs|xlog]\w+)\s*\(/;
205                         next unless defined($1);
206                         my $name = $1;
207                         if (defined($func)) {
208                                 $funcs{$name} = $func;  # store function away
209                         }
210                 }
211         }
212         close KERN;
213         return %funcs;
214 }
215
216 sub diffme {
217         my ( $sa, $sb ) = @_;
218
219         return unless defined($xdiff);
220
221         open(FILEA, "> /tmp/diff.user.$$") || die "cannot write to /tmp/diff.user.$$";
222         open(FILEB, "> /tmp/diff.kern.$$") || die "cannot write to /tmp/diff.kern.$$";
223         print FILEA $sa;
224         print FILEB $sb;
225         close FILEA;
226         close FILEB;
227         `$xdiff /tmp/diff.user.$$ /tmp/diff.kern.$$`;
228         unlink ("/tmp/diff.user.$$","/tmp/diff.kern.$$");
229 }
230
231 sub functiondiff {
232         my ( $file, $prefix1, $prefix2 ) = @_;
233         my $plural = '';
234         my $count = 0;
235         my $name;
236         my $found = 0;
237
238         print "\n=== Checking $file routines ===\n" unless ($quiet);
239
240         # iterate over user funcs, match up to kernel funcs
241         # 
242         my @user = listfuncs "$prefix1/$file";
243         my %kern = hashfuncs "$prefix2/$file";
244
245         foreach my $userfunc (@user) {
246                 
247                 $userfunc =~ m/^([xfs|xlog]\w+)\s*\(/;
248                 next unless (defined($1));
249                 $name = $1;
250                 $count++;
251
252                 if (exists($kern{$name})) {
253                         if ($userfunc ne $kern{$name}) {
254                                 print "\n=== $file routines ===\n"
255                                     if (!$found++ && $quiet);
256                                     
257                                 printf("\t%-35s ... ", $name);
258                                 print "FAILED\n";
259                                 diffme $userfunc, $kern{$name};
260                         }
261                         elsif (!$quiet) {
262                                 printf("\t%-35s ... ", $name);
263                                 print "ok\n";
264                         }
265                 }
266                 else {
267                         print "Cannot find kernel function $userfunc";
268                         print " in file $prefix2/$file\n";
269                 }
270         }
271         ($count != 1) && ( $plural = 's' );
272         print "( Total: $count routine$plural checked in $file )\n" unless ($quiet);
273 }
274
275 # xfsprogs/{libxfs,libxlog}/* fs/xfs/*
276 my @funclist = qw(
277         xfs_alloc.c  xfs_alloc_btree.c  xfs_attr_leaf.c
278         xfs_bmap.c  xfs_bmap_btree.c  xfs_btree.c  xfs_da_btree.c
279         xfs_dir.c  xfs_dir2.c  xfs_dir2_block.c  xfs_dir2_data.c
280         xfs_dir2_leaf.c  xfs_dir2_node.c  xfs_dir2_sf.c
281         xfs_dir_leaf.c  xfs_ialloc.c  xfs_ialloc_btree.c
282         xfs_inode.c  xfs_rtalloc.c  xfs_mount.c  xfs_trans.c
283 );
284
285 print "\n=== Checking libxfs code ===\n";
286 foreach (@funclist) {
287         functiondiff $_, 'xfsprogs/libxfs', "$kworkarea/fs/xfs";
288 }
289 print "\n=== Checking libxlog code ===\n";
290 functiondiff 'xfs_log_recover.c', 'xfsprogs/libxlog', "$kworkarea/fs/xfs";